///* gvSIG. Sistema de Información Geográfica de la Generalitat Valenciana
// *
// * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
// *
// * This program is free software; you can redistribute it and/or
// * modify it under the terms of the GNU General Public License
// * as published by the Free Software Foundation; either version 2
// * of the License, or (at your option) any later version.
// *
// * This program is distributed in the hope that it will be useful,
// * but WITHOUT ANY WARRANTY; without even the implied warranty of
// * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// * GNU General Public License for more details.
// *
// * You should have received a copy of the GNU General Public License
// * along with this program; if not, write to the Free Software
// * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
// *
// * For more information, contact:
// *
// *   Generalitat Valenciana
// *   Conselleria d'Infraestructures i Transport
// *   Av. Blasco Ibañez, 50
// *   46010 VALENCIA
// *   SPAIN
// *
// *   +34 963862235
// *   gvsig@gva.es
// *   www.gvsig.gva.es
// *
// *    or
// *
// *   IVER T.I. S.A
// *   Salamanca 50
// *   46005 Valencia
// *   Spain
// *
// *   +34 963163400
// *   dac@iver.es
// */
//package org.gvsig.publish.geoserver.config;
//
//import java.awt.geom.Rectangle2D;
//import java.io.File;
//import java.io.IOException;
//import java.net.MalformedURLException;
//import java.net.URI;
//import java.net.URISyntaxException;
//import java.net.URL;
//
//import junit.framework.TestCase;
//
//import org.gvsig.publish.geoserver.conf.GSConfiguration;
//import org.gvsig.publish.geoserver.conf.GSDatastore;
//import org.gvsig.publish.geoserver.conf.GSFeature;
//import org.gvsig.publish.geoserver.conf.GSNamespace;
//import org.gvsig.publish.geoserver.conf.GSServer;
//import org.gvsig.publish.geoserver.conf.GSStyle;
//import org.gvsig.publish.geoserver.conf.GSWFS;
//import org.gvsig.publish.geoserver.conf.GSWMS;
//
//public class Test_WriteConf extends TestCase {
//	
//	private File conf_dir;
//	private File resources_dir;
//	/**
//	 * Creates the Geoserver DATA_DIR
//	 * 
//	 */
//	protected void setUp() throws Exception {
//		//creates conf directory
//		conf_dir = new File ("test"); 
//		conf_dir.mkdirs();		
//		System.out.println("GEOSERVER_DATA_DIR: " + conf_dir.getAbsolutePath());
//		//init resources dir
//		resources_dir = new File("resources");
//		System.out.println("RESOURCES_DIR: " + resources_dir.getAbsolutePath());
//	}
//
//	public Geoserver createGeoserver(){
//		
//	}
//	public GSConfiguration createConfiguration(){
//		//create configuration
//		GSConfiguration conf = new GSConfiguration();
//		conf.setUser("admin");
//		conf.setPassword("geoserver");
//		
//		//configure services.global
//		GSServer srvs = conf.getGlobals();
//		srvs.setMaxFeatures(1000);
//		srvs.setLoginLevel(GSServer.GSServer);
//		srvs.setAdminPassword("geoserver");
//		srvs.setAdminUser("admin");
//		srvs.setCharset("UTF-8");
//		srvs.setImageIOCache(false);
//		srvs.setJaiJPEGNative(true);
//		srvs.setJaiMemoryCapacity(0.5);
//		srvs.setJaiMemoryThreshold(0.75);
//		srvs.setJaiPNGNative(true);
//		srvs.setJaiRecycling(true);
//		srvs.setJaiTilePriority(5);
//		srvs.setJaiTileThreads(7);
//		srvs.setLoginToFile(false);
//		srvs.setNumDecimals(8);
//		srvs.setVerbose(false);
//		srvs.setVerboseExceptions(false);
//		return conf;
//	}
//	
//	public GSWFS configure_wfs(GSConfiguration conf){
//		//configure services.wfs
//		GSWFS wfs = conf.getGlobals().getWFS();		
//		wfs.setName("WGS:WFS");
//		wfs.setTitle("Geoserver WFS");
//		wfs.setAbstract("Geoserver OGC-WFS test service");
//		wfs.addKeyword("wfs");
//		wfs.addKeyword("Geoserver");
//		wfs.setEnabled(true);
//		try {
//			wfs.setOnlineResource(new URL("http://localhost:8080/geoserver/wfs"));
//		} catch (MalformedURLException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		return wfs;		
//	}
//	public GSWMS configure_wms(GSConfiguration conf){
//		//configure services.wms
//		GSWMS wms = conf.getGlobals().getWMS();		
//		wms.setName("WGS:WMS");
//		wms.setTitle("Geoserver WMS");
//		wms.setAbstract("Geoserver OGC-WMS test service");
//		wms.addKeyword("wms");
//		wms.addKeyword("Geoserver");
//		wms.setEnabled(true);
//		try {
//			wms.setOnlineResource(new URL("http://localhost:8080/geoserver/wms"));
//		} catch (MalformedURLException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		return wms;
//		
//	}
//
//	public GSNamespace create_namespace(){
//		GSNamespace ns = new GSNamespace();
//		ns.setPrefix("ns_prefix");
//		try {
//			ns.setURI(new URI("http://localhost/geoserver"));
//		} catch (URISyntaxException e1) {			
//			e1.printStackTrace();
//		}
//		return ns;
//	}
//	public GSDatastore create_datastore_roads(GSNamespace ns){
//		GSDatastore ds = new GSDatastore();
//		ds.setId("sfRoads");
//			//ds.setEnabled(true);
//		ds.setCharset("ISO-8859-1");
//		ds.setNamespace(ns);
//		try {
//			String f = resources_dir.getAbsolutePath() + File.separator + "shp" + File.separator + "roads.shp";
//			ds.setURL(new URL("file:" + f));
//		} catch (MalformedURLException e) {
//			e.printStackTrace();
//		}		
//		return ds;
//
//	}
//	/**
//	 * Testing postgis datastores. 
//	 * Content example in the catalog.xml
//	 * 	
//		<datastore namespace = "default" enabled = "true" id = "postgis_id" >
//	    <abstract>descripcion datastore</abstract>
//	    <connectionParams >
//	      <parameter value = "default" name = "namespace" />
//	      <parameter value = "true" name = "loose bbox" />
//	      <parameter value = "postgres" name = "user" />
//	      <parameter value = "postgres" name = "passwd" />
//	      <parameter value = "false" name = "estimated extent" />
//	      <parameter value = "true" name = "wkb enabled" />
//	      <parameter value = "localhost" name = "host" />
//	      <parameter value = "public" name = "schema" />
//	      <parameter value = "5432" name = "port" />
//	      <parameter value = "publish" name = "database" />
//	      <parameter value = "postgis" name = "dbtype" />
//	    </connectionParams>
//	  </datastore>
//	*/
//
//	private GSDatastore create_datastore_postgis(GSNamespace ns) {
//		GSDatastore ds = new GSDatastore();
//		ds.setNamespace(ns);
//		ds.setId("test_postgis");
//			//ds.setEnabled(true);
//			//ds.setCharset("ISO-8859-1");
//		ds.setAbstract("descripcion del datastore postgis");
//		ds.setLooseBbox(true);
//		ds.setUser("postgres");
//		ds.setPassword("postgres");
//		ds.setEstimatedExtent(false);
//		ds.setHost("localhost");
//		ds.setSchema("public");
//		ds.setPort(5432);
//		ds.setDatabase("publish");
//		ds.setDbType("postgis");
//		return ds;
//	}
//	
//	public GSStyle create_style_roads(){
//		//create style
//		GSStyle st = new GSStyle();
//		st.setId("simple_roads");
//		File f = new File (resources_dir.getAbsoluteFile() + File.separator + "sld" + File.separator + "simpleRoads.sld");
//		st.setSLDString(f.toString());
//		return st;
//	}
//	
//	public void writeConf(GSConfiguration conf) throws IOException{		
//		//write configuration
//		conf.toXML(conf_dir);		
//		//reload conf
//		conf.reload(new URL("http://localhost:8080/geoserver"));
//	}
//	
//	/**
//	 * Creates a configuration for a shapefile 
//	 * @throws IOException 
//	 */
//	public void test_feature_shape() throws IOException{
//		//create conf
//		GSConfiguration conf = createConfiguration();
//		//configure wfs
//		configure_wfs(conf);
//		//configure wms
//		configure_wms(conf);
//		//create namespace
//		GSNamespace ns = create_namespace();
//		//create datastore
//		GSDatastore ds = create_datastore_roads(ns);
//		//create style 
//		GSStyle st = create_style_roads();
//		//create feature
//		GSFeature ft = new GSFeature();
//		ft.setDatastore(ds);
//		ft.setNamespace(ns);
//		ft.setStyle(st);
//		ft.setName("roads");
//		ft.setTitle("roads_Type");
//		ft.setAbstract("Generated from sfRoads");
//		ft.addKeyword("sfRoads");
//		ft.addKeyword("roads");
//		ft.setSRID(26713);
//		ft.setLatLonBBox(new Rectangle2D.Double(-7.555555229087563, 35.94874548545378, -1.6313474381419066, 38.614699115836444));
//		ft.setNativeBBox(new Rectangle2D.Double(102912.609375, 3987436.25, 619271.8125, 4274256.0));
//		//adds feature
//		conf.addFeatureType(ft);
//		//write conf
//		writeConf(conf);
//	}
//
//	public void test_feature_postgis() throws IOException{
//		//create conf
//		GSConfiguration conf = createConfiguration();
//		//configure wfs
//		configure_wfs(conf);
//		//configure wms
//		configure_wms(conf);
//		//create namespace
//		GSNamespace ns = create_namespace();
//		//create datastore
//		GSDatastore ds = create_datastore_postgis(ns);
//		//create style 
//		GSStyle st = create_style_roads();
//		//create feature
//		GSFeature ft = new GSFeature();
//		ft.setDatastore(ds);
//		ft.setNamespace(ns);
//		ft.setStyle(st);
//		ft.setName("roads");
//		ft.setTitle("test_postgis");
//		ft.setAbstract("Testing postgis datasource");
//		ft.addKeyword("test");
//		ft.addKeyword("postgis");
//		ft.setSRID(23030);
//		ft.setLatLonBBox(new Rectangle2D.Double(-103.87741691493184,44.37087275281798,609527.2102150217,4928063.398014731));
//		ft.setNativeBBox(new Rectangle2D.Double(589434.8564686741,4914006.337837095,609527.2102150217,4928063.398014731));
//		//adds feature
//		conf.addFeatureType(ft);
//		//write conf
//		writeConf(conf);
//	}
//	
//
//}
