/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.geoserver.gui;
import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.JFrame;

import org.gvsig.publish.PublishRegister;
import org.gvsig.publish.exceptions.InvalidRemoteResourceException;
import org.gvsig.publish.geoserver.model.Geoserver;
import org.gvsig.publish.geoserver.model.GeoserverFeature;
import org.gvsig.publish.geoserver.model.GeoserverWFSService;
import org.gvsig.publish.gui.publish.PublishController;
import org.gvsig.publish.serversmodel.Publication;
import org.gvsig.publish.serversmodel.RemoteResource;
import org.gvsig.publish.serversmodel.Server;
import org.gvsig.publish.serversmodel.Service;
/**
 * Tests the Mapserver GUI 
 * 
 * @author jvhigon
 *
 */
public class Test_GeoserverGUI{
	static public PublishController ctrl = null;
	static public Publication publication=null;
	static public Server server=null;
	static public Service service=null;
	static public RemoteResource rr=null;
		
	public static void main(String[] args) {
	    //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.		
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
        		public void run() {
				    try {
						createModel();
					} catch (InvalidRemoteResourceException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				    createController();
				    registerController();
				    showGUI();
				}
      });
		
    }
	
    private static void createModel() throws InvalidRemoteResourceException{
    	publication = new Publication();
    	server = new Geoserver();
    	try {
			server.setServerURL(new URL("http://localhost:8080/geoserver"));
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		publication.setServer(server);
		service = new GeoserverWFSService((Geoserver)server);
		server.addService(service);
		rr = new GeoserverFeature((GeoserverWFSService)service);		
		service.addRemoteResource(rr);		
	}
    private static  void createController(){
    	ctrl = new PublishController();
    	ctrl.setPublication(publication);
    	
    }
    private static void registerController(){
        //register controller 
    	PublishRegister.register().addController(Geoserver.REGISTER_TAG, GeoserverController.class);
    	
    }
	
	private static void showGUI(){
        //Create and set up the window.
        JFrame frame = new JFrame("Testing Geoserver GUI");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        //Add the publish panel        
        frame.getContentPane().add(ctrl.getWindow());
        //Display the window.
        frame.pack();
        frame.setVisible(true);
		
	}

}
