/* gvSIG. Sistema de Información Geográfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibañez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.geoserver.model;

import java.io.File;
import java.net.MalformedURLException;

import org.gvsig.publish.serversmodel.ServerTest;

public class GeoserverTest extends ServerTest {

	
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.publish.serversmodel.ServerTest#getServerClass()
	 */
	public Class getServerClass() {	
		return Geoserver.class;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.publish.serversmodel.ServerTest#getServerRegisterTag()
	 */
	public String getServerRegisterTag() {
	
		return Geoserver.REGISTER_TAG;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.publish.serversmodel.ServerTest#getServiceClass()
	 */
	public Class getServiceClass() {
	
		return GeoserverWFSService.class;
	}

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.publish.serversmodel.ServerTest#getServiceRegisterTag()
	 */
	public String getServiceRegisterTag() {

		return GeoserverWFSService.REGISTER_TAG;
	}
	/* (non-Javadoc)
	 * @see org.gvsig.publish.serversmodel.ServerTest#testGetXMLEntity()
	 */
	
	public void testGetXMLEntity() throws MalformedURLException {
		((Geoserver)server).setConfigDirectory(new File("test_dir"));
		super.testGetXMLEntity();
	}

	/* (non-Javadoc)
	 * @see org.gvsig.publish.serversmodel.ServerTest#testSetXMLEntity()
	 */
	
	public void testSetXMLEntity() throws MalformedURLException {
		((Geoserver)server).setConfigDirectory(new File("test_dir"));
		super.testSetXMLEntity();
	}

}
