/* gvSIG. Sistema de Información Geográfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibañez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.geoserver;

import org.gvsig.publish.PublishRegister;
import org.gvsig.publish.geoserver.gui.GeoserverController;
import org.gvsig.publish.geoserver.model.Geoserver;
import org.gvsig.publish.geoserver.model.GeoserverFeature;
import org.gvsig.publish.geoserver.model.GeoserverWFSService;

import com.iver.andami.plugins.Extension;

public class GeoserverExtension extends Extension {

	public void execute(String actionCommand) {
		// TODO Auto-generated method stub

	}
	/**
	 * Register the server, its services, remote resources and the GUI controller.
	 */
	public void initialize() {
		//Register the server		
		PublishRegister.register().addServer(Geoserver.REGISTER_TAG, Geoserver.class);		
		//Register the services
		PublishRegister.register().addService(Geoserver.REGISTER_TAG, GeoserverWFSService.REGISTER_TAG , GeoserverWFSService.class);
		//PublishRegister.register().addService(Geoserver.REGISTER_TAG, GSWMSService.REGISTER_TAG , GSWMSService.class);
		//Register the remote resources
		PublishRegister.register().addRemoteResource(Geoserver.REGISTER_TAG, GeoserverWFSService.REGISTER_TAG, GeoserverFeature.REGISTER_TAG, GeoserverFeature.class);
		//Register controller
		PublishRegister.register().addController(Geoserver.REGISTER_TAG, GeoserverController.class);

	}
	/**
	 * @return true if the extension is enabled
	 */
	public boolean isEnabled() {

		return true;
	}

	public boolean isVisible() {
		// TODO Auto-generated method stub
		return false;
	}

}
