/* gvSIG. Sistema de Información Geográfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibañez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */

package org.gvsig.publish.geoserver.conf;

import java.net.URI;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

/**
 * This class represents a namespace in the Geoserver Configuration
 * 
 * @author jvhigon (josevicente.higon@iver.es)
 */
public class GSNamespace  {
	private String prefix;
	private URI uri;
   
    /**
     * Default constructor
     */
    public GSNamespace (){
    }
    /**
     * Sets the namespace prefix
     * @param prefix namespace
     */
    public void setPrefix(String prefix) {
        this.prefix = prefix;
    }
    /**
     * 
     * @return unique value to identify the namespace
     */
    public String getPrefix(){
    	return this.prefix;
    }
	
    /**
     * Sets the namespace URI
     * @param uri 
     */
    public void setURI(URI uri) {
        this.uri = uri;
    }
	/**
	 * 
	 * @return namespace element to insert into a XML
	 */
	public Node getXMLElement(Document dom) {
		//set root element
		Element rootEle = dom.createElement("namespace");
		//set attributes
		rootEle.setAttribute("prefix", this.prefix);
		rootEle.setAttribute("uri",this.uri.toString());		
		return rootEle;
	}
}
