/* gvSIG. Sistema de Información Geográfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibañez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.geoserver.conf;

import org.gvsig.publish.geoserver.model.GeoserverWFSService;
import org.gvsig.publish.ogcmetadata.IOGCServiceMetadata;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.Text;

/**
 * This class represents the Geoserver WFS configuration
 * @author jvhigon
 *
 */
public class GSWFS extends GSService {
	private GeoserverWFSService geoserverwfs;
	/**
	 * Constructor
	 * @param service
	 */
	public GSWFS(GeoserverWFSService geoserverwfs) {
		super((IOGCServiceMetadata)geoserverwfs);
		this.geoserverwfs = geoserverwfs;
	}	

	/**
	 * @return string "WFS"
	 */
	public String getType() {
		return "WFS";
	}

	/**
	 * 
	 */
	public Node getXMLElement(Document dom) {		
		Node rootEle = super.getXMLElement(dom);
		//TODO:serviceLevel
		Element paramEle = dom.createElement("serviceLevel");
		Text txt = dom.createTextNode(new Integer(geoserverwfs.getServiceLevel()).toString());
		paramEle.appendChild(txt);
		rootEle.appendChild(paramEle);
		//TODO:citeConformanceHacks		
		return rootEle; 
	}

	
}
