/* gvSIG. Sistema de Información Geográfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibañez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.geoserver.gui;

import java.util.EventListener;

import javax.swing.JPanel;

import org.gvsig.publish.geoserver.model.GeoserverFeature;
import org.gvsig.publish.gui.publish.IPublishPluginPanel;

import com.iver.andami.PluginServices;

public class GSFeatureResourceAdvancedPanel extends JPanel implements
IPublishPluginPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -8723910393681961233L;
	//Associations
	private GeoserverFeature model;

	/**
	 * Default constructor
	 */
	public GSFeatureResourceAdvancedPanel() {
		super();
		initComponents();
		initLabels();
	}
	/**
	 * Initializes labels for multi-language
	 */
	private void initLabels() {
		cacheCheck.setText(PluginServices.getText(this, "publishgs_is_cached"));
		nsLabel.setText(PluginServices.getText(this,"publishgs_namespace"));
	}

    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        cacheCheck = new javax.swing.JCheckBox();
        cacheSpinner = new javax.swing.JSpinner();
        nsLabel = new javax.swing.JLabel();
        nsText = new javax.swing.JTextField();

        setLayout(new java.awt.GridBagLayout());

        cacheCheck.setSelected(true);
        cacheCheck.setText("is_cached");
        cacheCheck.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 2, 2);
        add(cacheCheck, gridBagConstraints);

        cacheSpinner.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(3600), null, null, Integer.valueOf(1)));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 2, 5);
        add(cacheSpinner, gridBagConstraints);

        nsLabel.setText("namespace");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 2, 2);
        add(nsLabel, gridBagConstraints);

        nsText.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(nsText, gridBagConstraints);
    }// </editor-fold>
    
    
    // Variables declaration - do not modify
    private javax.swing.JCheckBox cacheCheck;
    private javax.swing.JSpinner cacheSpinner;
    private javax.swing.JLabel nsLabel;
    private javax.swing.JTextField nsText;
    // End of variables declaration

	/*
	 * (non-Javadoc)
	 * @see org.gvsig.publish.gui.publish.IPublishPluginPanel#getModel()
	 */
	public Object getModel() {
		//model.getConfig().setOgcMetadata((CommonOGCMetadata)commonOgc.getModel());
		model.setCacheEnabled(cacheCheck.isSelected());
		model.setCacheMaxage(new Integer(cacheSpinner.getModel().getValue().toString()).intValue());
		model.setNamespacePrefix(nsText.getText());
		return model;
	}
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.publish.gui.publish.IPublishPluginPanel#setListener(java.util.EventListener)
	 */
	public void setListener(EventListener listener) {
		// TODO Auto-generated method stub

	}
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.publish.gui.publish.IPublishPluginPanel#setModel(java.lang.Object)
	 */
	public void setModel(Object entityModel) {
		// cast to geoserver feature remote resource
		model = (GeoserverFeature)entityModel;
		cacheCheck.setSelected(model.isCacheEnabled());
		cacheSpinner.getModel().setValue(new Integer(model.getCacheMaxage()));
		nsText.setText(model.getNamespacePrefix());
	}

}
