/* gvSIG. Sistema de Información Geográfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibañez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.geoserver.gui;

import javax.swing.JFileChooser;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;
/**
 * File chooser for geoserver config directory
 * @author jvhigon
 *
 */
public class GSFileChooser extends JFileChooser implements IWindow {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1814253147508247962L;
	private WindowInfo mWindowInfo = null;
	/**
	 * default constructor
	 */
	public GSFileChooser() {
		setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	}
	/**
	 * @return information about the window. Needed by gvSIG
	 */
	public WindowInfo getWindowInfo() {
		if (mWindowInfo == null){
			//mWindowInfo=new WindowInfo(WindowInfo.MODALDIALOG | WindowInfo.RESIZABLE);
			mWindowInfo=new WindowInfo(WindowInfo.MODELESSDIALOG | WindowInfo.RESIZABLE);
			mWindowInfo.setTitle(PluginServices.getText(this,"mapfile_chooser_window"));
			mWindowInfo.setHeight(100);
			mWindowInfo.setWidth(200);
        }
        return mWindowInfo;

	}

}
