/* gvSIG. Sistema de Información Geográfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibañez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.geoserver.gui;

import java.util.EventListener;

import javax.swing.JPanel;

import org.gvsig.publish.geoserver.model.GeoserverWFSService;
import org.gvsig.publish.gui.publish.IPublishPluginPanel;

import com.iver.andami.PluginServices;

public class GSWFSAdvancedPanel extends JPanel implements
		IPublishPluginPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 8140265272523362936L;
	//Associations 
	private GeoserverWFSService model=null;
	/**
	 * default constructor
	 */
	public GSWFSAdvancedPanel() {
		super();
		initComponents();
		initLabels();
	}
	/**
	 * Initializes labels for multi-language
	 */
	private void initLabels() {
		serviceLabelLabel.setText(PluginServices.getText(this, "publishgs_service_level"));		
	}
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        serviceLabelLabel = new javax.swing.JLabel();
        serviceLevelCombo = new javax.swing.JComboBox();

        setLayout(new java.awt.GridBagLayout());

        serviceLabelLabel.setText("service_level");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 2, 2);
        add(serviceLabelLabel, gridBagConstraints);

        serviceLevelCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Basic", "Transactional", "Complete" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 2, 5);
        add(serviceLevelCombo, gridBagConstraints);
    }// </editor-fold>
    
    
    // Variables declaration - do not modify
    private javax.swing.JLabel serviceLabelLabel;
    private javax.swing.JComboBox serviceLevelCombo;
    // End of variables declaration
        
	    
	public Object getModel() {
		model.setServiceLevel(getServiceLevelFromCombo(serviceLevelCombo.getSelectedIndex()));
		return model;
	}

	public void setListener(EventListener listener) {
		// TODO Auto-generated method stub

	}

	public void setModel(Object entityModel) {
		// cast to geoserverwfs
		model = (GeoserverWFSService)entityModel;		
		serviceLevelCombo.setSelectedIndex(getComboIndexFromServiceLevel(model.getServiceLevel()));		
	}
	/**
	 * 
	 * @param comboindex 0 --> Basic, 1 --> Transactional, 2 --> Complete
	 * @return geoserver integer to specify a service level
	 */
	private int getServiceLevelFromCombo(int comboindex){
		//Basic
		if (comboindex == 0){
			return 1;
		}
		//Transactional
		if (comboindex == 1){
			return 15;
		}
		//Complete
		if (comboindex == 2){
			return 31;
		}
		return 0;
	}
	/**
	 * 
	 * @param serviceLevel 1-->Basic, 15-->Transactional, 31-->Complete 
	 * @return comboindex which represents the serviceLevel parameter 
	 */
	private int getComboIndexFromServiceLevel(int serviceLevel){
		//Basic
		if (serviceLevel == GeoserverWFSService.LEVEL_BASIC){
			return 0;
		}
		//Transactional
		if (serviceLevel == GeoserverWFSService.LEVEL_TRANSACTIONAL){
			return 1;
		}
		//Complete
		if (serviceLevel == GeoserverWFSService.LEVEL_COMPLETE){
			return 2;
		}
		return 0;		
	}

}
