/* gvSIG. Sistema de Información Geográfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibañez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.geoserver.gui;

import java.util.EventListener;

import javax.swing.JPanel;

import org.gvsig.publish.geoserver.model.Geoserver;
import org.gvsig.publish.gui.publish.IPublishPluginPanel;

import com.iver.andami.PluginServices;

public class GeoserverAdvancedPanel extends JPanel implements
IPublishPluginPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3420736554303339083L;
	//Association
	private Geoserver model=null;

	/**
	 * Default constructor
	 */
	public GeoserverAdvancedPanel() {
		super();
		initComponents();
		initLabels();		
	}
	/**
	 * Initializes labels for multi-language
	 */
	private void initLabels() {
		maxFeatLabel.setText(PluginServices.getText(this,"publishgs_max_features"));
        logLevelLabel.setText(PluginServices.getText(this,"publishgs_login_level"));       
	}
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        maxFeatSpinner = new javax.swing.JSpinner();
        maxFeatLabel = new javax.swing.JLabel();
        logLevelLabel = new javax.swing.JLabel();
        logLevelCombo = new javax.swing.JComboBox();

        setLayout(new java.awt.GridBagLayout());

        maxFeatSpinner.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(1000), null, null, Integer.valueOf(10)));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 2, 5);
        add(maxFeatSpinner, gridBagConstraints);

        maxFeatLabel.setText("max_features");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 2, 2);
        add(maxFeatLabel, gridBagConstraints);

        logLevelLabel.setText("login_level");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(2, 5, 2, 2);
        add(logLevelLabel, gridBagConstraints);

        logLevelCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "SEVERE", "WARNING", "INFO", "CONFIG", "FINER", "FINEST" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(logLevelCombo, gridBagConstraints);
    }// </editor-fold>
    
    
    // Variables declaration - do not modify
    private javax.swing.JComboBox logLevelCombo;
    private javax.swing.JLabel logLevelLabel;
    private javax.swing.JLabel maxFeatLabel;
    private javax.swing.JSpinner maxFeatSpinner;
    // End of variables declaration

	public Object getModel() {
		Object value = maxFeatSpinner.getModel().getValue();
		model.setMaxFeatures(new Integer(value.toString()).intValue());
		model.setLogginLevel(logLevelCombo.getSelectedItem().toString());
		return model;
	}

	public void setListener(EventListener listener) {
		// TODO Auto-generated method stub

	}

	public void setModel(Object entityModel) {
		model = (Geoserver)entityModel;
		logLevelCombo.setSelectedItem(model.getLogginLevel());
		maxFeatSpinner.setValue(new Integer(model.getMaxFeatures()));
	}

}
